 Build.PL          | 2 +-
 c_bin/makefile    | 6 +++---
 lib/Bio/DB/Sam.xs | 9 ++++++---
 3 files changed, 10 insertions(+), 7 deletions(-)

diff --git a/Build.PL b/Build.PL
index 1393e03..cf97ad5 100644
--- a/Build.PL
+++ b/Build.PL
@@ -38,7 +38,7 @@ my $build = $class->new(
     dist_abstract      => 'Perl interface to SamTools library for DNA sequencing',
     license            => 'perl',
     include_dirs       => [$sam_include],
-    extra_linker_flags => ["-L$sam_lib",'-lbam','-lpthread','-lz'],
+    extra_linker_flags => ["-L$sam_lib",'-lbam','-lhts','-lpthread','-lz'],
 
     extra_compiler_flags=>[
 
diff --git a/c_bin/makefile b/c_bin/makefile
index 9aef917..96a30f2 100644
--- a/c_bin/makefile
+++ b/c_bin/makefile
@@ -1,5 +1,5 @@
-CC=		gcc
-CFLAGS=		-g -Wall -O2 -fPIC
+CC?=		gcc
+CFLAGS?=		-g -Wall -O2 -fPIC
 DFLAGS=		-D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE -D_USE_KNETFILE -D_CURSES_LIB=1
 INCLUDES=
 LIBPATH=
@@ -14,7 +14,7 @@ PROG=		bam2bedgraph
 all:$(PROG)
 
 bam2bedgraph: bam2bedgraph.o
-	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS) $(LIBPATH) -lbam -lpthread -lm -lz
+	$(CC) $(CFLAGS) -o $@ $< $(LDFLAGS) $(LIBPATH) -lbam -lhts -lpthread -lm -lz
 
 clean:
 	rm -f *.o $(PROG)
diff --git a/lib/Bio/DB/Sam.xs b/lib/Bio/DB/Sam.xs
index 5ca303b..7f92860 100644
--- a/lib/Bio/DB/Sam.xs
+++ b/lib/Bio/DB/Sam.xs
@@ -571,9 +571,12 @@ bama_l_aux(b,...)
     Bio::DB::Bam::Alignment b
 PROTOTYPE: $;$
 CODE:
-    if (items > 1)
-      b->l_aux = SvIV(ST(1));
-    RETVAL=b->l_aux;
+    if (items > 1) {
+      RETVAL = SvIV(ST(1));
+      }
+    else {
+      RETVAL=bam_get_l_aux(b);
+    }
 OUTPUT:
     RETVAL
 
